Loading...
Searching...
No Matches
OpenMesh::Decimater::ModHausdorffT< MeshT > Class Template Reference

Use Hausdorff distance to control decimation. More...

`#include <OpenMesh/Tools/Decimater/ModHausdorffT.hh>`

Inheritance diagram for OpenMesh::Decimater::ModHausdorffT< MeshT >:
[legend]
Collaboration diagram for OpenMesh::Decimater::ModHausdorffT< MeshT >:
[legend]

## Public Types

typedef ModHausdorffT< MeshT > | Self
typedef OpenMesh::Decimater::ModHandleT< Self > | Handle
typedef OpenMesh::Decimater::ModBaseT< MeshT > | Base
typedef Base::Mesh | Mesh
typedef Base::CollapseInfo | CollapseInfo
typedef Mesh::Scalar | Scalar
typedef Mesh::Point | Point
typedef Mesh::FaceHandle | FaceHandle
typedef std::vector< Point > | Points
Public Types inherited from OpenMesh::Decimater::ModBaseT< MeshT >
enum | { ILLEGAL_COLLAPSE = -1 , LEGAL_COLLAPSE = 0 }
typedef MeshT | Mesh
typedef CollapseInfoT< MeshT > | CollapseInfo

## Public Member Functions

virtual const std::string & | name () const override
| Set module's name.
| ModHausdorffT (MeshT &_mesh, Scalar _error_tolerance=FLT_MAX)
| Constructor.
| ~ModHausdorffT ()
| Destructor.
Scalar | tolerance () const
| get max error tolerance
void | set_tolerance (Scalar _e)
| set max error tolerance
virtual void | initialize () override
| reset per-face point lists
virtual float | collapse_priority (const CollapseInfo &_ci) override
| compute Hausdorff error for one-ring
virtual void | postprocess_collapse (const CollapseInfo &_ci) override
| re-distribute points
void | set_error_tolerance_factor (double _factor) override
| set the percentage of tolerance
Public Member Functions inherited from OpenMesh::Decimater::ModBaseT< MeshT >
virtual | ~ModBaseT ()
| Virtual desctructor.
bool | is_binary (void) const
| Returns true if criteria returns a binary value.
void | set_binary (bool _b)
| Set whether module is binary or not.
virtual float | collapse_priority (const CollapseInfoT< MeshT > &)
| Return collapse priority.
virtual void | preprocess_collapse (const CollapseInfoT< MeshT > &)
| Before _from_vh has been collapsed into _to_vh, this method will be called.
virtual void | postprocess_collapse (const CollapseInfoT< MeshT > &)
| After _from_vh has been collapsed into _to_vh, this method will be called.

## Additional Inherited Members

Protected Member Functions inherited from OpenMesh::Decimater::ModBaseT< MeshT >
| ModBaseT (MeshT &_mesh, bool _is_binary)
| Default constructor.
MeshT & | mesh ()
| Access the mesh associated with the decimater.
Protected Attributes inherited from OpenMesh::Decimater::ModBaseT< MeshT >
double | error_tolerance_factor_

## Detailed Description

template<class MeshT>
class OpenMesh::Decimater::ModHausdorffT< MeshT >

Use Hausdorff distance to control decimation.

This module computes the aspect ratio.

In binary mode, the collapse is legal if:

- The distance after the collapse is lower than the given tolerance

No continuous mode

## Member Function Documentation

## collapse_priority()

template<class MeshT>

float OpenMesh::Decimater::ModHausdorffT< MeshT >::collapse_priority | ( | const CollapseInfo & | _ci | ) |

override virtual

compute Hausdorff error for one-ring

This mod only allows collapses if the Hausdorff distance after a collapse is lower than the given tolerance.

Parameters

  _ci | Collapse info data

Returns
  Binary return, if collapse is legal or illegal

## initialize()

template<class MeshT>

void OpenMesh::Decimater::ModHausdorffT< MeshT >::initialize | ( | void |  | ) |

override virtual

reset per-face point lists

Reimplemented from OpenMesh::Decimater::ModBaseT< MeshT >.

## name()

template<class MeshT>

virtual const std::string & OpenMesh::Decimater::ModHausdorffT< MeshT >::name | ( |  | ) | const

inline override virtual

Set module's name.

Reimplemented from OpenMesh::Decimater::ModBaseT< MeshT >.

## set_error_tolerance_factor()

template<class MeshT>

void OpenMesh::Decimater::ModHausdorffT< MeshT >::set_error_tolerance_factor | ( | double | _factor | ) |

override virtual

set the percentage of tolerance

Reimplemented from OpenMesh::Decimater::ModBaseT< MeshT >.

The documentation for this class was generated from the following files:

- OpenMesh/Tools/Decimater/ModHausdorffT.hh
- OpenMesh/Tools/Decimater/ModHausdorffT_impl.hh